enum Prop {
    PROP_0,
    PROP_HOST_HOSTNAME,
    PROP_HOST_UUID,
    PROP_HOST_CUSTOM_UUID,
    PROP_HOST_OS,
    PROP_HOST_ARCH,
    PROP_HOST_WORDSIZE,
    PROP_HOST_MEMORY,
    PROP_HOST_SWAP,
    PROP_HOST_CPU_COUNT,
    PROP_HOST_CPU_CORES,
    PROP_HOST_CPU_MODEL,
    PROP_HOST_CPU_FLAGS,
    PROP_HOST_UPDATE_INTERVAL,
    PROP_HOST_LAST_UPDATED,
    PROP_HOST_SEQUENCE,
    PROP_HOST_FREE_MEM,
    PROP_HOST_FREE_SWAP,
    PROP_HOST_LOAD,
    PROP_HOST_PROCESS_STATISTICS,
    };
Property properties[] = {
    { PROP_HOST_HOSTNAME, "hostname", "hostname", "Hostname", G_PARAM_READABLE, 's' },
    { PROP_HOST_UUID, "uuid", "uuid", "Filesystem Host UUID", G_PARAM_READABLE, 's' },
    { PROP_HOST_CUSTOM_UUID, "custom_uuid", "custom_uuid", "Custom Host UUID", G_PARAM_READABLE, 's' },
    { PROP_HOST_OS, "os", "os", "The installed operating system.", G_PARAM_READABLE, 's' },
    { PROP_HOST_ARCH, "arch", "arch", "The host's architecture", G_PARAM_READABLE, 's' },
    { PROP_HOST_WORDSIZE, "wordsize", "wordsize", "The wordsize for the host", G_PARAM_READABLE, 'y' },
    { PROP_HOST_MEMORY, "memory", "memory", "Amount of primary memory for host", G_PARAM_READABLE, 't' },
    { PROP_HOST_SWAP, "swap", "swap", "Amount of swap for host", G_PARAM_READABLE, 't' },
    { PROP_HOST_CPU_COUNT, "cpu_count", "cpu_count", "The number of logical CPUs.", G_PARAM_READABLE, 'y' },
    { PROP_HOST_CPU_CORES, "cpu_cores", "cpu_cores", "The total number of processor cores.", G_PARAM_READABLE, 'y' },
    { PROP_HOST_CPU_MODEL, "cpu_model", "cpu_model", "The processor(s) model description.", G_PARAM_READABLE, 's' },
    { PROP_HOST_CPU_FLAGS, "cpu_flags", "cpu_flags", "The processor(s) CPU flags.", G_PARAM_READABLE, 's' },
    { PROP_HOST_UPDATE_INTERVAL, "update_interval", "update_interval", "The interval at which the host sends out heartbeats and refreshes statistics.", G_PARAM_READWRITE, 'u' },
    { PROP_HOST_LAST_UPDATED, "last_updated", "last_updated", "The last time a heartbeat occurred.", G_PARAM_READABLE, 'i' },
    { PROP_HOST_SEQUENCE, "sequence", "sequence", "The heartbeat sequence number.", G_PARAM_READABLE, 'u' },
    { PROP_HOST_FREE_MEM, "free_mem", "free_mem", "Amount of available memory for host", G_PARAM_READABLE, 't' },
    { PROP_HOST_FREE_SWAP, "free_swap", "free_swap", "Amount of available swap for host", G_PARAM_READABLE, 't' },
    { PROP_HOST_LOAD, "load", "load", "The one/five/fifteen minute load average", G_PARAM_READABLE, 'e' },
    { PROP_HOST_PROCESS_STATISTICS, "process_statistics", "process_statistics", "Number of processes in each possible state", G_PARAM_READABLE, 'e' },
    { PROP_0, NULL, NULL, NULL, 0, '\0' },
};