
//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "QmfPackage.h"
#include <qmf/Schema.h>
#include <qmf/SchemaProperty.h>
#include <qmf/SchemaMethod.h>
#include <string>

using namespace std;
using namespace qmf::org::matahariproject;

void PackageDefinition::configure(::qmf::AgentSession& session)
{
    string package("org.matahariproject");

    //
    // Data: Host
    //
    data_Host = qmf::Schema(SCHEMA_TYPE_DATA, package, "Host");
    {
        qmf::SchemaProperty prop("hostname", qmf::SCHEMA_DATA_STRING);
        prop.setAccess(qmf::ACCESS_READ_ONLY);
        prop.setIndex(true);
        prop.setDesc("Hostname");
        data_Host.addProperty(prop);
    }

    {
        qmf::SchemaProperty prop("uuid", qmf::SCHEMA_DATA_STRING);
        prop.setAccess(qmf::ACCESS_READ_ONLY);
        prop.setIndex(true);
        prop.setDesc("Filesystem Host UUID");
        data_Host.addProperty(prop);
    }

    {
        qmf::SchemaProperty prop("custom_uuid", qmf::SCHEMA_DATA_STRING);
        prop.setAccess(qmf::ACCESS_READ_ONLY);
        prop.setIndex(true);
        prop.setDesc("Custom Host UUID");
        data_Host.addProperty(prop);
    }

    {
        qmf::SchemaProperty prop("os", qmf::SCHEMA_DATA_STRING);
        prop.setAccess(qmf::ACCESS_READ_ONLY);
        prop.setDesc("The installed operating system.");
        data_Host.addProperty(prop);
    }

    {
        qmf::SchemaProperty prop("arch", qmf::SCHEMA_DATA_STRING);
        prop.setAccess(qmf::ACCESS_READ_ONLY);
        prop.setDesc("The host's architecture");
        data_Host.addProperty(prop);
    }

    {
        qmf::SchemaProperty prop("wordsize", qmf::SCHEMA_DATA_INT);
        prop.setAccess(qmf::ACCESS_READ_ONLY);
        prop.setUnit("bit");
        prop.setDesc("The wordsize for the host");
        data_Host.addProperty(prop);
    }

    {
        qmf::SchemaProperty prop("memory", qmf::SCHEMA_DATA_INT);
        prop.setAccess(qmf::ACCESS_READ_ONLY);
        prop.setUnit("kb");
        prop.setDesc("Amount of primary memory for host");
        data_Host.addProperty(prop);
    }

    {
        qmf::SchemaProperty prop("swap", qmf::SCHEMA_DATA_INT);
        prop.setAccess(qmf::ACCESS_READ_ONLY);
        prop.setUnit("kb");
        prop.setDesc("Amount of swap for host");
        data_Host.addProperty(prop);
    }

    {
        qmf::SchemaProperty prop("cpu_count", qmf::SCHEMA_DATA_INT);
        prop.setAccess(qmf::ACCESS_READ_ONLY);
        prop.setDesc("The number of logical CPUs.");
        data_Host.addProperty(prop);
    }

    {
        qmf::SchemaProperty prop("cpu_cores", qmf::SCHEMA_DATA_INT);
        prop.setAccess(qmf::ACCESS_READ_ONLY);
        prop.setDesc("The total number of processor cores.");
        data_Host.addProperty(prop);
    }

    {
        qmf::SchemaProperty prop("cpu_model", qmf::SCHEMA_DATA_STRING);
        prop.setAccess(qmf::ACCESS_READ_ONLY);
        prop.setDesc("The processor(s) model description.");
        data_Host.addProperty(prop);
    }

    {
        qmf::SchemaProperty prop("cpu_flags", qmf::SCHEMA_DATA_STRING);
        prop.setAccess(qmf::ACCESS_READ_ONLY);
        prop.setDesc("The processor(s) CPU flags.");
        data_Host.addProperty(prop);
    }

    {
        qmf::SchemaProperty prop("update_interval", qmf::SCHEMA_DATA_INT);
        prop.setAccess(qmf::ACCESS_READ_WRITE);
        prop.setUnit("s");
        prop.setDesc("The interval at which the host sends out heartbeats and refreshes statistics.");
        data_Host.addProperty(prop);
    }

    {
        qmf::SchemaProperty prop("last_updated", qmf::SCHEMA_DATA_INT);
        prop.setSubtype("abstime");
        prop.setDesc("The last time a heartbeat occurred.");
        data_Host.addProperty(prop);
    }

    {
        qmf::SchemaProperty prop("sequence", qmf::SCHEMA_DATA_INT);
        prop.setDesc("The heartbeat sequence number.");
        data_Host.addProperty(prop);
    }

    {
        qmf::SchemaProperty prop("free_mem", qmf::SCHEMA_DATA_INT);
        prop.setUnit("kb");
        prop.setDesc("Amount of available memory for host");
        data_Host.addProperty(prop);
    }

    {
        qmf::SchemaProperty prop("free_swap", qmf::SCHEMA_DATA_INT);
        prop.setUnit("kb");
        prop.setDesc("Amount of available swap for host");
        data_Host.addProperty(prop);
    }

    {
        qmf::SchemaProperty prop("load", qmf::SCHEMA_DATA_MAP);
        prop.setDesc("The one/five/fifteen minute load average");
        data_Host.addProperty(prop);
    }

    {
        qmf::SchemaProperty prop("process_statistics", qmf::SCHEMA_DATA_MAP);
        prop.setDesc("Number of processes in each possible state");
        data_Host.addProperty(prop);
    }

    {
        qmf::SchemaMethod method("identify");
        method.setDesc("Tell the host to beep its pc speaker.");
        data_Host.addMethod(method);
    }

    {
        qmf::SchemaMethod method("shutdown");
        method.setDesc("Shutdown node");
        data_Host.addMethod(method);
    }

    {
        qmf::SchemaMethod method("reboot");
        method.setDesc("Reboot node");
        data_Host.addMethod(method);
    }

    {
        qmf::SchemaMethod method("get_uuid");
        method.setDesc("Obtain a UUID with the specified lifetime from the machine");
        {
            qmf::SchemaProperty arg("lifetime", qmf::SCHEMA_DATA_STRING);
            arg.setDirection(qmf::DIR_IN);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("uuid", qmf::SCHEMA_DATA_STRING);
            arg.setDirection(qmf::DIR_OUT);
            method.addArgument(arg);
        }

        data_Host.addMethod(method);
    }

    {
        qmf::SchemaMethod method("set_uuid");
        method.setDesc("Set a UUID with the specified lifetime");
        {
            qmf::SchemaProperty arg("lifetime", qmf::SCHEMA_DATA_STRING);
            arg.setDirection(qmf::DIR_IN);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("uuid", qmf::SCHEMA_DATA_STRING);
            arg.setDirection(qmf::DIR_IN);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("rc", qmf::SCHEMA_DATA_INT);
            arg.setDirection(qmf::DIR_OUT);
            method.addArgument(arg);
        }

        data_Host.addMethod(method);
    }

    {
        qmf::SchemaMethod method("set_power_profile");
        method.setDesc("Set power management profile");
        {
            qmf::SchemaProperty arg("profile", qmf::SCHEMA_DATA_STRING);
            arg.setDirection(qmf::DIR_IN);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("status", qmf::SCHEMA_DATA_INT);
            arg.setDirection(qmf::DIR_OUT);
            method.addArgument(arg);
        }

        data_Host.addMethod(method);
    }

    {
        qmf::SchemaMethod method("get_power_profile");
        method.setDesc("Get current power management profile");
        {
            qmf::SchemaProperty arg("profile", qmf::SCHEMA_DATA_STRING);
            arg.setDirection(qmf::DIR_OUT);
            method.addArgument(arg);
        }

        data_Host.addMethod(method);
    }

    {
        qmf::SchemaMethod method("list_power_profiles");
        method.setDesc("List available power management profiles");
        {
            qmf::SchemaProperty arg("profiles", qmf::SCHEMA_DATA_LIST);
            arg.setDirection(qmf::DIR_OUT);
            method.addArgument(arg);
        }

        data_Host.addMethod(method);
    }

    session.registerSchema(data_Host);

    //
    // Event: heartbeat
    //
    event_heartbeat = qmf::Schema(SCHEMA_TYPE_EVENT, package, "heartbeat");
    event_heartbeat.setDefaultSeverity(qmf::SEV_INFORM);
    {
        qmf::SchemaProperty prop("timestamp", qmf::SCHEMA_DATA_INT);
        prop.setSubtype("abstime");
        event_heartbeat.addProperty(prop);
    }

    {
        qmf::SchemaProperty prop("sequence", qmf::SCHEMA_DATA_INT);
        event_heartbeat.addProperty(prop);
    }

    {
        qmf::SchemaProperty prop("hostname", qmf::SCHEMA_DATA_STRING);
        event_heartbeat.addProperty(prop);
    }

    {
        qmf::SchemaProperty prop("uuid", qmf::SCHEMA_DATA_STRING);
        event_heartbeat.addProperty(prop);
    }

    session.registerSchema(event_heartbeat);

}

